<?php
/*
Plugin Name: Add No-Follow
Plugin URI: http://www.tecnocracia.com.br/
Description: Searches the text for links to wikipedia and add rel='no-follow'..
Author: Manoel Netto
Version: 0.1
Author URI: http://www.tecnocracia.com.br/
*/

// Add new domains here (do not add * or %, only the final part)
$domains_to_add_nofollow = array ( "wikipedia.org" );

function wp_extract_domain_name_from_uri($uri){
	// /^(http:\/\/)?([^\/]+)/i -> original
	preg_match("/^(http:|https:|ftp:|ftps:)?(?:\/\/)?([^\/]+)/i", $uri, $matches);
	$host = $matches[2];
	// /(?:\.[^\.\/]+){2,3}$/        (original) /[^\.\/]+\.[^\.\/]+$/
	preg_match("/[^\.\/]+(?:\.[^\.\/]+){0,2}$/", $host, $matches);
	return $matches[0];	   
}


function parse_nofollow_links($matches) {
	global $domains_to_add_nofollow;
	foreach ($domains_to_add_nofollow as $each_domain) {
		if ( strstr(wp_extract_domain_name_from_uri($matches[3]), $each_domain) ){
			return '<a href="' . $matches[2] . '//' . $matches[3] . '"' . $matches[1] . $matches[4] . ' rel="nofollow">' . $matches[5] . '</a>';	 
		} else {
			return '<a href="' . $matches[2] . '//' . $matches[3] . '"' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>';
		}
	}
}
	

function wp_add_nofollow($text) {
	$pattern = '/<a (.*?)href="(.*?)\/\/(.*?)"(.*?)>(.*?)<\/a>/i';
	$text = preg_replace_callback($pattern,'parse_nofollow_links',$text);

	$pattern2 = '/<a (.*?) rel="nofollow"(.*?)>(.*?)<img (.*?)<\/a>/i';
	$text = preg_replace($pattern2, '<a $1 $2>$3<img $4</a>', $text);
	return $text;
}

// filters have high priority to make sure that any markup plugins like Textile or Markdown have already created the HTML links
add_filter('the_content', 'wp_add_nofollow', 999);
add_filter('the_excerpt', 'wp_add_nofollow', 999);

// delete this one if you don't want it run on comments
add_filter('comment_text', 'wp_add_nofollow', 999);
?>